/**
 *
 * addableEdge.java -- used in SEuS structure discovery system
 * Copyright (C) 2002 Shayan Ghazizadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

/**
 * This class is a container for an edge with all the necessary information to add it
 * to an existing subGraph.
 */
public class addableEdge {
    public labelNode from;
    public labelNode to;
    public edgeLabel edge;

    public int connected2;
    /**
     * 1 --> myHead == hisHead
     * 2 --> myHead == hisTail
     * 3 --> myTail == hisHead
     * 4 --> myTail == hisTail
     */
    public int connDetail;

    public addableEdge(labelNode f, labelNode t, edgeLabel e) {
	from = f;
	to = t;
	edge = e;
    }

    public addableEdge() {
    }


    public int occMax() {
	int min = from.occ;
	if (to.occ < min)
	    min = to.occ;
	if (edge.occ < min)
	    min = edge.occ;
	return min;
    }
}

