/**
 *
 * addableEdgeCompare.java -- used in SEuS structure discovery system
 * Copyright (C) 2002 Shayan Ghazizadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

import java.util.*;

/**
  * Implements the Comparator interface for addableEdge structure.
  * Objects are compared based on occ value.
  */
public class addableEdgeCompare implements Comparator {
    public int compare(Object o1, Object o2) {
	if (!(o1 instanceof addableEdge))
	    throw new ClassCastException();
	if (!(o2 instanceof addableEdge))
	    throw new ClassCastException();
	/*
	if (((addableEdge)o1).occMax() < ((addableEdge)o2).occMax())
	    return 1;
	else if (((addableEdge)o1).occMax() == ((addableEdge)o2).occMax())
	    return 0;
	else
	    return -1;
	*/
	if (((addableEdge)o1).edge.id > ((addableEdge)o2).edge.id)
	    return 1;
	else if (((addableEdge)o1).edge.id == ((addableEdge)o2).edge.id)
	    return 0;
	else
	    return -1;
    }

    public boolean equals(Object o) {
	if (!(o instanceof addableEdgeCompare))
	    return false;
	return true;
    }
}
