/**
 *
 * latticeNode.java -- used in SEuS structure discovery system
 * Copyright (C) 2002 Shayan Ghazizadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


/*
 * Implements the class used for the second level summary
 * nodes.
 */

import java.util.*;

public class latticeNode {
    // The number of nodes with exactly this outgoing edges.
    private int count;
    
    // The outgoing edges
    private ArrayList outgoing;

    public latticeNode() {
	outgoing = new ArrayList();
	count = 0;
    }

    public void first() {
	count = 1;
    }

    public void inc() {
	count++;
    }


    public void add(String e, String d) {
	outgoing.add(e+"--"+d);
    }


    public boolean equals(Object o) {
	if (!(o instanceof latticeNode))
	    return false;
	
	latticeNode o2 = (latticeNode)o;

	Collections.sort(outgoing);
	Collections.sort(o2.outgoing);
	return outgoing.equals(o2.outgoing);
    }

    public int getCount() {
	return count;
    }

    public int subset(latticeNode n) {
	int idx=0;
	int res=0;
	ArrayList l = (ArrayList)n.outgoing.clone();

	while (true) {
	    Iterator it = outgoing.iterator();
	    while (it.hasNext()) {
		if ((idx = l.indexOf(((String)it.next()))) == -1)
		    return res;
		l.remove(idx);
	    }
	    res++;
	}
    }
}
