/**
 *
 * subInstance.java -- used in SEuS structure discovery system
 * Copyright (C) 2002 Shayan Ghazizadeh
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */


/**
 * This class stores information about a structure's instance in db.
 * The information contains:
 *   - number of vertices
 *   - id's of vertices
 */
public class subInstance implements Cloneable, java.io.Serializable {
    public int[] ids;
    public int idCount;

    /**
     * Implements the classic equals method for this class.
     * Two labelNodes are equal, if the id's and their numbers are equal.
     */
    public boolean equals(Object o) {
	if (o instanceof subInstance) {
	    subInstance obj = (subInstance)o;

	    if (obj.idCount != idCount)
		return false;

	    for (int i=0; i<idCount; i++) 
		if (ids[i] != obj.ids[i])
		    return false;
	    return true;
	}
	return false;
    }

    /**
     * Implementation of Object.clone() method.
     */
    public Object clone() {
	subInstance copy = new subInstance(ids.length);
	copy.idCount = idCount;
	for (int i=0; i<idCount; i++)
	    copy.ids[i] = ids[i];
	return copy;
    }

    public Object clone(int d) {
	subInstance copy = new subInstance(ids.length+1);
	copy.idCount = idCount+1;
	for (int i=0; i<idCount; i++)
	    copy.ids[i] = ids[i];
	return copy;
    }

    public subInstance(int size) {
	idCount = 0;
	ids = new int[size];
    }
}
